<template>
  <rui-form model="observation"
            :errors="errors"
            :loading="loading"
            @cancel="$emit('cancel')"
            @submit.prevent="save">
    <rui-field :input-id="`${formId}-title`" :label="$t('activerecord.attributes.observation.title')">
      <input :id="`${formId}-title`" v-model="inputs.title" type="text" required>
    </rui-field>

    <rui-date-time-picker ref="datePicker"
                          v-model="inputs.madeAt"
                          :label="$t('js.observations.form.date')"
                          :time="false"
                          :input-id="`${formId}-date`"
                          :popup="true"
                          :not-after="today"
                          input-name="date" />

    <rui-field :input-id="`${formId}-content`" :label="$t('activerecord.attributes.observation.content')">
      <textarea :id="`${formId}-content`" v-model="inputs.content" name="content" />
    </rui-field>

    <template v-if="subject && !observation">
      <rui-field :input-id="`${formId}-pictures`" :label="$t('activerecord.attributes.observation.pictures')" :help="$t('js.observations.form.accepted_mimes', {types: acceptedMimeTypes})">
        <input :id="`${formId}-pictures`"
               type="file"
               :accept="acceptedMimeTypes"
               multiple
               @change="handlePicturesSelection">
      </rui-field>

      <div class="rui-thumbnails">
        <div v-for="(file, index) in inputs.pictures" :key="index" class="_thumbnail">
          <img :src="file.source" :alt="file.file.name">
          <rui-button :caption="$t('generic.remove')" variant="destructive" icon="x-bold" @click="removePicture(index)" />
        </div>
      </div>
    </template>
    <rui-alert v-else-if="observation.pictures.length > 0" variant="info">{{ $t('js.observation.edit.cannot_change_pictures_yet') }}</rui-alert>
  </rui-form>
</template>

<script>
import RuiAlert from '@experiments-labs/rise_ui/src/components/Alert/Alert.vue'
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'
import RuiDateTimePicker from '@experiments-labs/rise_ui/src/components/Inputs/DateTimePicker/DateTimePicker.vue'

import { randomString } from '@experiments-labs/rise_ui/src/lib/String.js'
import Toaster from '../../../../tools/Toaster'
import Element from '../../../../classes/models/Element'
import Map from '../../../../classes/models/Map'
import Observation from '../../../../classes/models/Observation'
import Patch from '../../../../classes/models/Patch'
import Path from '../../../../classes/models/Path'

export default {
  name: 'GpaObservationForm',
  emits: [
    'cancel',
    'done',
  ],
  components: { RuiAlert, RuiButton, RuiDateTimePicker, RuiField, RuiForm },
  props: {
    subject: { required: false, type: [Element, Map, Patch, Path], default: null },
    observation: { required: false, type: [Observation], default: null },
  },
  data () {
    return {
      loading: false,
      errors: null,
      formId: randomString(),
      today: new Date(),
      // FIXME: Find a better way to pass configuration constants
      acceptedMimeTypes: OBSERVATIONS_ALLOWED_MIME_TYPES,
      inputs: {
        title: this.$props.observation?.title || '',
        content: this.$props.observation?.content || '',
        pictures: [],
        madeAt: this.$props.observation?.madeAt || new Date(),
      },
    }
  },
  methods: {
    save () {
      const isNew = this.subject && !this.observation
      this.errors = null
      const payload = {
        title: this.inputs.title,
        content: this.inputs.content,
        made_at: this.inputs.madeAt,
      }

      if (isNew) {
        payload.subject_id = this.$props.subject.id
        payload.subject_type = this.$props.subject.className
        payload.pictures = []
        for (const picture of this.inputs.pictures) {
          payload.pictures.push(picture.file)
        }
      } else {
        payload.id = this.$props.observation.id
      }

      this.loading = true
      this.$store.dispatch(isNew ? 'createObservation' : 'updateObservation', payload)
        .then(() => {
          this.$emit('done')
          Toaster.success(this.$t('js.observation.successfully_created'))
        })
        .catch((error) => {
          this.errors = error
          Toaster.error(this.$t('js.observation.failed_to_create'))
        })
        .then(() => { this.loading = false })
    },
    handlePicturesSelection (event) {
      const files = event.target.files || event.dataTransfer.files
      const that = this

      for (const file of files) {
        const reader = new FileReader()
        reader.addEventListener('load', (event) => {
          const image = new Image()
          image.src = event.target.result
          image.onload = function (loadEvent) {
            /** @type {HTMLImageElement} */
            const picture = loadEvent.target
            const canvasElement = document.createElement('canvas')

            const largestSide = picture.width > loadEvent.target.height ? picture.width : picture.height
            const scaleResize = OBSERVATIONS_LARGEST_PICTURE_SIZE / largestSide

            canvasElement.width = picture.width * scaleResize
            canvasElement.height = picture.height * scaleResize

            const ctx = canvasElement.getContext('2d')
            ctx.drawImage(picture, 0, 0, canvasElement.width, canvasElement.height)

            const preview = ctx.canvas.toDataURL('image/jpeg', 1)
            ctx.canvas.toBlob((blob) => {
              const finalFile = new File([blob], file.fileName, {
                type: 'image/jpeg',
                lastModified: new Date().valueOf(),
              })
              that.inputs.pictures.push({ file: finalFile, source: preview })
            }, 'image/jpeg', 1)
          }
        })
        reader.readAsDataURL(file)
      }
    },
    removePicture (index) {
      this.inputs.pictures.splice(index, 1)
    },
  },
}
</script>
